#!/usr/bin/perl

# Getweather script for oer by Tero Nybacka <sivis@sivis.org>
# oer version 1.0-58 or newer required

# $Id: getweather.pl,v 1.9 2002/10/20 23:41:14 vekotin Exp $

# Fixed the script so city names with spaces are splitted in two arguments

use oer_ext;

# When used as "ext saa" show this city's weather info

$default_city = "Tampere";

# This option tells what pages are used when generating informations
# Number is the number in url: http://www.tiehallinto.fi/alk/tiesaa/tiesaa_maak_<number>.html
# Numbers can be found from http://www.tiehallinto.fi/alk/frames/tiesaa-frame-new.html
# "main" means the mainpage at http://www.tiehallinto.fi/alk/tiesaa/tiesaa_kokomaa.html
# will be used

# This example will get EVERYTHING from every area of Finland. Very bandwidth consuming
#@pages = ("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","main");

# Our default here will only get the main list
@pages = ("main");

# What word is used to trigger the script (ext <word>)
$script_trigger = "saa";

# Don't edit anything below this line unless you know what you're doing

my %cities;

foreach $tmp (@pages)
{
  if(lc($tmp) eq "main")
  {
    $url="http://www.tiehallinto.fi/alk/tiesaa/tiesaa_kokomaa.html";
  }
  else
  {
    $url="http://www.tiehallinto.fi/alk/tiesaa/tiesaa_maak_$tmp.html";
  }
  open(fd, "lynx -nolist -dump $url | ") or die("Error while opening $url");
  while(<fd>)
  {
    if(/\s*Tie (\d*); (.*)\s+(\d*):(\d*)\s+(\-?\d*).(\d*)\s+(\-?\d*).(\d*)\s+(\S+)\s+(.+)/) {
      ($city, $road) = split(/, /, $2, 2);
      $after = "Ilma: $5.$6 C Tie: $7.$8 C (Sade: $9, Keli: $10)";
      $before = "Kello $3:$4";
      $road =~ s/\s+$//;
      $city =~ s/\s+$//;
      if($road)
      {
        $rest = "$before $city ($road) $after";
      }
      else
      {
        $rest = "$before $city, $after";
      }
      %cities->{$city} = $rest;
    }
  }
  close fd;
}


foreach $tmp (keys %cities)
{
  ($city1, $city2) = split(/ /, $tmp, 2);
  if(lc($tmp) eq lc($default_city))
  {
    print_line($script_trigger,"","","","",$cities{$tmp});
  }
  print_line($script_trigger,$city1,$city2,"","",$cities{$tmp});
}
